package com.realnet.student.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.student.Entity.Student;
import com.realnet.student.Services.StudentService ;








@RequestMapping(value = "/token/Student")
 @CrossOrigin("*") 
@RestController
public class tokenFree_StudentController {
	@Autowired
	private StudentService Service;

@Value("${projectPath}")
	private String projectPath;
 








	@PostMapping("/Student")
		  public Student Savedata(@RequestBody Student data) {
		Student save = Service.Savedata(data)	;







		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Student/{id}")
	public  Student update(@RequestBody Student data,@PathVariable Integer id ) {
		Student update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Student/getall/page")
	public Page<Student> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Student> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Student")
	public List<Student> getdetails() {
		 List<Student> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Student")
	public List<Student> getallwioutsec() {
		 List<Student> get = Service.getdetails();		
		return get;
}
@GetMapping("/Student/{id}")
	public  Student  getdetailsbyId(@PathVariable Integer id ) {
		Student  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Student/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}









}